"use strict";

this.name      = "ups_sun_station_alpha"; 
this.author    = "eric walch"; 
this.copyright = "� 2008 eric walch."; 
this.version   = "1.01";

this.playerArrived = false;

this.shipSpawned = function ()
{
    if (worldScripts["ups_sun"].ups_sun === "RESCUE" || worldScripts["ups_sun"].ups_sun === "EXPLOSION")
    {
        this.ship.switchAI("upsSunStationFinalAI.plist"); // switch AI script on final mission.
        this.ship.requiresDockingClearance = false;
    }
    var targetVector = system.sun.position.subtract(this.ship.position).direction();
    this.ship.orientation = targetVector.rotationTo(new Vector3D(0,0,1));
    this.buoy =  (this.ship.primaryRole == "ups_dependance") ? "ups-sun-buoy" : "ups-sun-buoy2";
    system.addShips(this.buoy, 1, this.ship.position.add(this.ship.heading.multiply(10E3)), 1);
    delete this.shipSpawned;
}

this.shipDied = function () 
{ 
    if (worldScripts["ups_sun"].ups_sun === "RESCUE" || worldScripts["ups_sun"].ups_sun === "EXPLOSION")
    {
        log(this.name, "Station position is: "+this.ship.position);
        var escapees = system.addShips("sunbase-upscapsule", 15, this.ship.position, 500);
        for (var i=0; i<escapees.length; i++)
        {
            // escapees[i].position = this.ship.position.add(Vector3D.random().multiply(500));
            // escapees[i].velocity = escapees[i].position.subtract(this.ship.position);
            // log(this.name, "escapees position nr: "+i+" is: "+escapees[i].position);
        }
        worldScripts["ups_sun"].ups_rescue = "YES";
        worldScripts["ups_sun"].ups_sun = "EXPLOSION";
        delete this.shipDied;
    }
} 

this.entityDestroyed = function ()
{
	if (this.heatTimer) {this.heatTimer.stop(); delete this.heatTimer;};
}

this.takeHeatDamage = function ()
{
     if (!this.playerArrived)
     {
        this.playerArrived = true;
        this.heatTimer = new Timer(this, this.increaseHeat, 1, 1);
        this.ship.commsMessage("Help us evacuate our last soles.");
     }
     else 
	 {
		var temp = Math.round(100 - 60 * this.ship.energy / this.ship.maxEnergy);
		this.ship.commsMessage("Hurry up, station core temperature is at "+temp+" degr C and still rising.");
	 }
}

this.increaseHeat = function ()
{
    this.ship.temperature += 0.01;
    if (this.ship.temperature >= 1) {this.heatTimer.stop(); delete this.heatTimer};
}

this.launchMainstation = function ()
{
    var main = system.mainStation;
    if (main) main.launchShipWithRole("sunskim-trader");
}