"use strict";

this.name        = "ups_slaves"; 
this.author      = "eric walch"; 
this.copyright   = "� 2008 eric walch."; 
this.license     = "CC BY-NC-SA 3.0"; 
this.description = "Slaves missions of UPS Courier"; 
this.version     = "1.8.3";

this.startUp = function ()
{
    this.mark = false;
    this.upsMarkSystem = worldScripts["ups_docs"].upsMarkSystem;
    this.upsUnmarkSystem = worldScripts["ups_docs"].upsUnmarkSystem;
}

this.shipLaunchedFromStation = function ()
{
  if (this.ups_slaverescue)
  {
    this.setUpShips();
  }
}

this.missionScreenOpportunity = function ()
{
    // this.ups_slaverescue is set to "true" by a scooping a special escape_pod generated by a cobraIII.
    if (player.ship.docked && this.ups_slaverescue) 
    {
        this.missionOffers();
    }
}

this.guiScreenChanged = function (newScreen, oldScreen)
{
    if (this.restartMissionOffer && newScreen !== "GUI_SCREEN_LONG_RANGE_CHART")
    {
        this.restartMissionOffer = false;
        if (guiScreen !== "GUI_SCREEN_MISSION") this.missionOffers();
    }
}

this.missionOffers = function ()
{
	var slaveStatus = this.ups_slaves;
    if (player.ship.dockedStation.isMainStation)
    {
        if (slaveStatus === "SLAVE" && !worldScripts["ups_docs"].lookLongRangeChartScreen)
        {
                var message = expandMissionText("ups_slave_homeland", {ups_slavename: this.ups_slavename});
                mission.runScreen({title: "Slave Mission", message: message, 
                                    overlay: "UPS.png", choicesKey: "ups_slave_accepted_yesnolook"}, 
                                    this.choiceEvaluation);
                this.offering ="UPS_SLAVES_HOMELANDS";
        }
        if (slaveStatus === "HOMELAND" && this.ups_slplanet === system.ID)
        {
                this.ups_slaves = "NOT_NOW";
                this.upsUnmarkSystem(this.ups_slplanet, this.name);
                var message = expandMissionText("ups_slave_homeland2", {ups_slavename: this.ups_slavename});
                mission.runScreen({title: "Slave Mission", message: message, overlay: "UPS.png"});
                mission.setInstructionsKey(null);
                player.ship.manifest["gem-stones"] += 15;
                this.ups_slcount++;
                player.increasePassengerReputation();
        }
        if (slaveStatus === "RESCUEOFFER" && system.government > 3 && system.economy < 3 && !worldScripts["ups_docs"].lookLongRangeChartScreen)
        {
                var message = expandMissionText("ups_slave_rescueoffer", {ups_slavename: this.ups_slavename});
                mission.runScreen({title: "Slave Mission", message: message, 
                                overlay: "UPS.png", choicesKey: "ups_slave_accepted2_yesnolook"},
                                this.choiceEvaluation);
                this.offering ="UPS_SLAVES_RESCUE";
        }
        if (slaveStatus === "RESCUE" && system.ID === this.ups_sl2planet)
        {
				if (this.ups_convoy === "KILLED")
				{
					var key;
                    if (this.ups_sl2count > 10)
					{
						// rescued all
                        key = "ups_slave_rescue10";
                        player.ship.manifest["gem-stones"] += 50;
					} 
					else
					{
						if (this.ups_sl2count > 0) key = "ups_slave_rescue"
						else key = "ups_slave_rescue0"; // rescued none!
					}
                    var message = expandMissionText(key, {ups_slavesrescued: this.ups_sl2count, ups_slavename: this.ups_slavename});
                    mission.runScreen({title: "Slave Mission", message: message});
					this.resetConvoyMission();
					this.ups_slcount += 3;
				}
				else if (this.ups_convoy === "ADDED" && system.countShipsWithRole("ups-slaveconvoy") === 0)
				{
                    var message = expandMissionText("ups_slave_rescue_failure", {ups_slavename: this.ups_slavename});
					mission.runScreen({title: "Slave Mission", message: message});
					this.resetConvoyMission();
					this.ups_slcount -= 2;
				};
        }
        if (slaveStatus === "FINALOFFER" && system.government > 2)
        {
                var message = expandMissionText("ups_slave_final", {ups_slavename: this.ups_slavename});
                mission.runScreen({title: "Slave Mission", message: message, 
                                choicesKey: "ups_slave_accepted_yesno"}, this.choiceEvaluation);
                this.offering = "UPS_SLAVES_FINAL";
        }
        if (slaveStatus === "FINAL" && this.ups_slplanet === system.ID)
        {
            var message = expandMissionText("ups_slave_groundbattle", {ups_slavename: this.ups_slavename});
            mission.runScreen({title: "Slave Mission", message: message, model: "ups_slave_satellite", spinModel: false});
            this.$startCallback();
            this.ups_slaves = "GROUNDBATTLE";
            mission.setInstructionsKey("ups_slave_groundbattle_small");
            this.ups_slavesrescued = 5;
        }
        if (slaveStatus === "DEBRIEFING" && this.ups_slplanet === system.ID)
        {
            this.ups_slaves = "NOT_NOW";
            mission.setInstructionsKey(null);
            var key;
            if (this.ups_slavesrescued == 5)
            {
                key = "ups_slave_debriefing"; // rescued all
                player.credits += 6000;
            }
            else
            {
                if (!this.ups_slavesrescued)
                {
                    key = "ups_slave_debriefing2"; // rescued none
                }
                else
                {
                    key = "ups_slave_debriefing1";
                    player.credits += 4000;
                }
            }
            var message = expandMissionText(key, {ups_slavesrescued: this.ups_slavesrescued});
            mission.runScreen({title: "Slave Mission", message: message});
            mission.setInstructionsKey(null);
			this.upsUnmarkSystem(this.ups_slplanet, this.name);
            this.resetSlaves(galaxyNumber);
            return;
        }
    }
    if (player.ship.dockedStation.name === "Ground Radar")
    {
        if (slaveStatus === "DEBRIEFING" || slaveStatus === "GROUNDBATTLE")
        {
            mission.runScreen({title: "Slave Mission", messageKey: "ups_slave_trapped"});
            this.ups_slaves = "FAILED";
			this.upsUnmarkSystem(this.ups_slplanet, this.name)
            this.resetSlaves(galaxyNumber);
        }
    }
}

this.choiceEvaluation = function (choice)
{
    switch (this.offering)
    {
        case "UPS_SLAVES_HOMELANDS":
        {
            this.mark = false
            if (choice === "YESSlave")
            {
                this.upsMarkSystem(this.ups_slplanet, this.name);
                mission.setInstructions(expandMissionText("ups_slave_small", {ups_slavename: this.ups_slavename}));
                this.ups_slaves = "HOMELAND";
            }
            else if (choice === "LOOKSlave")
            {
                this.upsShowDestination(this.ups_slplanet);
            }
            else if (choice === "NOSlave")
            { 
                this.ups_slaves = "NOT_NOW";
                if (Math.random()<0.5) player.decreasePassengerReputation();
            }
            break;
        }
    
        case "UPS_SLAVES_RESCUE":
        {
            if (choice === "YESSlave")
            {
                this.upsMarkSystem(this.ups_sl2planet, this.name);
                mission.setInstructionsKey("ups_slave_small3");
                this.ups_slaves = "RESCUE";
                this.ups_sl2count = 0;
                this.ups_convoy = null;
            }
            else if (choice === "LOOKSlave")
            {
                this.upsShowDestination(this.ups_sl2planet);
            }
            else if (choice === "NOSlave")
            { 
                this.ups_slaves = "NOT_NOW";
            }
            break;
        }
    
        case "UPS_SLAVES_FINAL":
        {
            if (choice === "YESSlave")
            {
                this.upsMarkSystem(this.ups_slplanet, this.name);
                mission.setInstructions(expandMissionText("ups_slave_small2", {ups_slavename: this.ups_slavename}));
                this.ups_slaves = "FINAL";
            }
            else if (choice === "NOSlave")
            { 
                this.ups_slaves = "NOT_NOW";
            }
            break;
        }
        default: log(this.name, "Encountered an illegal mission offer: "+this.offering);
    }
    this.offering = null;
}

this.upsShowDestination = function (ID)
{
    this.mark = true; // Keep this selected system.
    if (0 < oolite.compareVersion("1.77"))
    {
        worldScripts.ups_docs.requestLongRangeChart(ID, "ups_slaves");
        mission.runScreen({title: "Container Mission", messageKey: "ups_long_range_screen"});
    }
    else
    {
        if (player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") == "EQUIPMENT_OK")
        {
            player.ship.targetSystem = ID;
            mission.runScreen({title: "Long Range Chart", backgroundSpecial: "LONG_RANGE_CHART_SHORTEST"});
        }
        else
        {
            mission.markSystem({
                       system: ID,
                       name: "ups_marker",
                       markerColor: "cyanColor",
                       markerScale: 2.0,
                       markerShape: "MARKER_DIAMOND"
            })
            var message = expandMissionText("ups_long_range_screen_2", {ups_system: System.systemNameForID(ID)});
            mission.runScreen({title: "Long Range Chart", message: message, backgroundSpecial: "LONG_RANGE_CHART"});
        }
    }
}

this.setUpShips = function ()
{
    if (this.ups_slaves === "GROUNDBATTLE")
    {
        if (system.ID === this.ups_slplanet && system.countShipsWithRole("ups_slave_satellite") === 0)
        {
            //system.legacy_addShipsAtPrecisely("ups_slave_satellite", 1, "pwp", [0, 0, 1.004]);
            //system.legacy_addShipsAtPrecisely("ups_slave_satellite", 1, "pwp", [0, 0.05, 1.004]);
            //system.legacy_addShipsAtPrecisely("ups_slave_satellite", 1, "pwp", [0.05, 0, 1.004]);
            //system.legacy_addShipsAtPrecisely("ups_slave_satellite", 1, "pwp", [0.05, 0.05, 1.004]);
            system.addShips("ups_slave_satellite", 1, Vector3D(0, 0, 1.004).fromCoordinateSystem("pwp"), 1);
            system.addShips("ups_slave_satellite", 1, Vector3D(0, 0.05, 1.004).fromCoordinateSystem("pwp"), 1);
            system.addShips("ups_slave_satellite", 1, Vector3D(0.05, 0, 1.004).fromCoordinateSystem("pwp"), 1);
            system.addShips("ups_slave_satellite", 1, Vector3D(0.05, 0.05, 1.004).fromCoordinateSystem("pwp"), 1);
            this.ups_satellitecount = 4;
			// Smallest planet radius = 30 000 meters. 0.004*30 000 = 120 meters. This just fits for the towers.
        }
    }
    if (this.ups_slaves === "RESCUE")
    {
        if (system.ID === this.ups_sl2planet && system.countShipsWithRole("ups-slaveconvoy") === 0 && !this.ups_convoy)
        {
            system.addShipsToRoute("ups-convoy-l", 1, 0.5, "wp");
			this.ups_convoy = "ADDED";
        }
    }
}

this.shipExitedWitchspace = function ()
{
  if (system.isInterstellarSpace) return;
  if (this.ups_slaverescue)
  {
    this.setUpShips();
    if (!this.ups_slaves)
    { // selection of a tyarget system for all slave missions. And make sure you don't select a Nova system.
        if (system.government === 2 && system.economy > 5 && !system.sun.hasGoneNova  && (!system.info.hasOwnProperty("market") || !system.info.market))
        {
            this.ups_slaves = "NO";
            this.ups_slplanet = system.ID;
            missionVariables.ups_slplanetname = system.name;
            this.ups_slcount = 0;
			missionVariables.ups_slplanetdescription = system.description;
			system.description = system.description + " Currently this planet is in civil war and is selling a lot of its inhabitants as slaves.";
            system.info.market = "ups_slaveplanet";
        }
    }
	var slaveStatus = this.ups_slaves;
    if (slaveStatus === "NOT_NOW" && Math.random() < 0.11) this.ups_slaves = "NO";
    if (slaveStatus === "NO")
    {
        if (this.ups_slcount > 5 && system.government > 2 && Math.random() > 0.9)
        {
            this.ups_slaves = "FINALOFFER";
        }
        else if (this.ups_slcount > 1 && Math.random() > 0.9 && system.government === 2 && !system.sun.hasGoneNova)
        {
            this.ups_slaves = "RESCUEOFFER";
            this.ups_sl2planet = system.ID;
            missionVariables.ups_sl2planetname = system.name;
        }
        else if (!system.isInterstellarSpace && Math.random() > 0.75 && system.economy < 3)
        {
			system.addShipsToRoute("ups-slavecobra", 1, Math.random()*0.8+0.1); // station route
        }
    }
  }
  else if (system.government === 2 && Math.random() > 0.5)
  {
    system.addShipsToRoute("ups_slave_start", 1, Math.random(), "wp");
  }
}

this.resetConvoyMission = function ()
{
    this.ups_sl2count = null;
    this.upsUnmarkSystem(this.ups_sl2planet, this.name);
    this.ups_sl2planet = null;
    missionVariables.ups_sl2planetname = null;
    this.ups_convoy = null;
    mission.setInstructionsKey(null);
    this.ups_slaves = "NOT_NOW";
};

this.resetSlaves = function (galaxy)
{
    // do some cleanup of variables
    mission.setInstructionsKey(null) 
	if (missionVariables.ups_slplanetdescription)
	{
		System.infoForSystem(galaxy, this.ups_slplanet).description = null;
        if (System.infoForSystem(galaxy, this.ups_slplanet).hasOwnProperty("market"))
        {
            System.infoForSystem(galaxy, this.ups_slplanet).market = null;
        }
		missionVariables.ups_slplanetdescription = null;
	}
    var deletions = ["slavename", "slplanetname", "sl2count", "sl2planetname"];
    for (var i=0; i<deletions.length; i++) delete missionVariables["ups_"+deletions[i]];
    var deletions2 = ["slaves", "slaverescue", "slplanet", "sl2planet", "slcount", "slavesrescued"];
    for (var i=0; i<deletions2.length; i++) this["ups_"+deletions2[i]] = null;
}

this.playerEnteredNewGalaxy = function (galaxy)
{
	if (this.ups_slaves)
	{
		var oldGalaxy = --galaxy;
		if (oldGalaxy < 0) oldGalaxy = 8;
		this.resetSlaves(oldGalaxy);
	}
}

this.$startCallback = function ()
{
    if (!isValidFrameCallback(this.$callbackID)) this.$callbackID = addFrameCallback(this.rotateDisplayModel.bind(this));
    this.displayModel = mission.displayModel;
};

this.rotateDisplayModel = function (delta)
{
    if (guiScreen != "GUI_SCREEN_MISSION" || !mission.displayModel || this.displayModel != mission.displayModel)
    {
        // we are finisched, or the missionscreen has changed.
        this.$cleanupCallback();
        return;
    };
    var q = new Quaternion(1,0,0,0);
    q = q.rotateY(0.1 * delta);
    mission.displayModel.orientation = mission.displayModel.orientation.multiply(q);

};

this.$cleanupCallback = function ()
{
	if (this.$callbackID && isValidFrameCallback(this.$callbackID))
	{ 
		removeFrameCallback(this.$callbackID);
        delete this.$callbackID;
	}
};